--- CMakeLists.txt.orig	2011-05-08 20:28:04.000000000 +0200
+++ CMakeLists.txt	2011-11-28 00:29:42.000000000 +0100
@@ -60,6 +60,26 @@
 set(OGRE_TEMPLATES_DIR "${OGRE_SOURCE_DIR}/CMake/Templates")
 set(OGRE_WORK_DIR ${OGRE_BINARY_DIR})
 
+####################
+# MACPORTS variables
+####################
+
+set(MACPORTS FALSE CACHE BOOL "Build OGRE for MacPorts")
+set(MACPORTS_DOC_DIR "@PREFIX@/share/doc" CACHE STRING
+  "The MacPorts documentation directory")
+set(MACPORTS_OGRE_DOC_DIR "${MACPORTS_DOC_DIR}/OGRE" CACHE STRING
+  "The OGRE directory in MacPorts documentation directory")
+set(MACPORTS_CMAKE_MODULE_PATH "${CMAKE_INSTALL_PREFIX}/share/cmake/modules"
+  CACHE STRING
+  "The path to MacPorts user-installed CMake modules")
+set(MACPORTS_SAMPLES_DIR "${MACPORTS_OGRE_DOC_DIR}/SDKSamples" CACHE STRING
+  "The path to OGRE Samples directory in a MacPorts distribution")
+set(MACPORTS_SAMPLES_SOURCE_DIR "${MACPORTS_SAMPLES_DIR}/Samples" CACHE STRING
+  "The path where the sample source code will be installed")
+set(MACPORTS_OGRE_DOCS_PATH "${MACPORTS_OGRE_DOC_DIR}/Docs" CACHE STRING
+  "The path where the Ogre Documentation will be installed")
+set(MACPORTS_OGRE_TOOLS_PATH "${MACPORTS_OGRE_DOC_DIR}/Tools" CACHE STRING
+  "Where the Ogre Tools will go")
 
 #####################################################################
 # Set up the basic build environment
@@ -168,6 +188,11 @@
     set(OGRE_STATIC TRUE)
   else ()
     include_directories("${OGRE_SOURCE_DIR}/OgreMain/include/OSX")
+    # If OGRE_STATIC, force CMake to select static versions
+    # of dependent libraries on MacOS X
+    if(OGRE_STATIC)
+      SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a;.framework")
+    endif ()
   endif ()
 endif (APPLE)
 
@@ -215,12 +240,14 @@
 elseif (APPLE AND NOT OGRE_BUILD_PLATFORM_IPHONE)
 
   # Set 10.5 as the base SDK by default
-  set(XCODE_ATTRIBUTE_SDKROOT macosx)
-  set(CMAKE_OSX_SYSROOT macosx)
+  #set(XCODE_ATTRIBUTE_SDKROOT macosx)
+  #set(CMAKE_OSX_SYSROOT macosx)
   set(CMAKE_OSX_DEPLOYMENT_TARGET 10.5)
 
   if (NOT CMAKE_OSX_ARCHITECTURES)
-    set(CMAKE_OSX_ARCHITECTURES $(ARCHS_STANDARD_32_64_BIT))
+    if (ARCHS_STANDARD_32_64_BIT)
+      set(CMAKE_OSX_ARCHITECTURES $(ARCHS_STANDARD_32_64_BIT))
+    endif()
   endif()
 
   # Make sure that the OpenGL render system is selected for non-iPhone Apple builds
